
local em 				= GetEventManager()
local wm 				= GetWindowManager()
local identifier		= "Dr_ThiefDB"
Dr_Thief_DB_currentPOI	= ""

if Dr_ThiefDB == nil then Dr_ThiefDB = {} end

Dr_ThiefDB.name = "ThiefDatabase"
Dr_ThiefDB.version = "0.0"
Dr_ThiefDB.default = {
	ThiefDatabase = {}
}

Dr_ThiefDB.cutpursesArt = {
	id = 90,
	index = 4
}

function Dr_ThiefDB.isCutpursesArtSlotted()
	for index=1, 4 do
		if GetSlotBoundId(index, HOTBAR_CATEGORY_CHAMPION) == 90 then
			return 1
		end
	end
	return 0
end

function Dr_ThiefDB.getItemType( itemLink )
	local item_tables = {
		[ITEMTYPE_ARMOR] = "ARMOR",
		[ITEMTYPE_ADDITIVE] = "ADDITIVE",
		[ITEMTYPE_ARMOR_BOOSTER] = "ARMOR_BOOSTER",
		[ITEMTYPE_ARMOR_TRAIT] = "ARMOR_TRAIT",
		[ITEMTYPE_AVA_REPAIR] = "AVA_REPAIR",
		[ITEMTYPE_BLACKSMITHING_BOOSTER] = "BLACKSMITHING_BOOSTER",
		[ITEMTYPE_BLACKSMITHING_MATERIAL] = "BLACKSMITHING_MATERIAL",
		[ITEMTYPE_BLACKSMITHING_RAW_MATERIAL] = "BLACKSMITHING_RAW_MATERIAL",
		[ITEMTYPE_CLOTHIER_BOOSTER] = "CLOTHIER_BOOSTER",
		[ITEMTYPE_CLOTHIER_MATERIAL] = "CLOTHIER_MATERIAL",
		[ITEMTYPE_CLOTHIER_RAW_MATERIAL] = "CLOTHIER_RAW_MATERIAL",
		[ITEMTYPE_COLLECTIBLE] = "COLLECTIBLE",
		[ITEMTYPE_CONTAINER] = "CONTAINER",
		[ITEMTYPE_CONTAINER_CURRENCY] = "CONTAINER_CURRENCY",
		[ITEMTYPE_COSTUME] = "COSTUME",
		[ITEMTYPE_CROWN_ITEM] = "CROWN_ITEM",
		[ITEMTYPE_CROWN_REPAIR] = "CROWN_REPAIR",
		[ITEMTYPE_DEPRECATED] = "DEPRECATED",
		[ITEMTYPE_DISGUISE] = "DISGUISE",
		[ITEMTYPE_DRINK] = "DRINK",
		[ITEMTYPE_DYE_STAMP] = "DYE_STAMP",
		[ITEMTYPE_ENCHANTING_RUNE_ASPECT] = "ENCHANTING_RUNE_ASPECT",
		[ITEMTYPE_ENCHANTING_RUNE_ESSENCE] = "ENCHANTING_RUNE_ESSENCE",
		[ITEMTYPE_ENCHANTING_RUNE_POTENCY] = "ENCHANTING_RUNE_POTENCY",
		[ITEMTYPE_ENCHANTMENT_BOOSTER] = "ENCHANTMENT_BOOSTER",
		[ITEMTYPE_FISH] = "FISH",
		[ITEMTYPE_FLAVORING] = "FLAVORING",
		[ITEMTYPE_FOOD] = "FOOD",
		[ITEMTYPE_FURNISHING] = "FURNISHING",
		[ITEMTYPE_FURNISHING_MATERIAL] = "FURNISHING_MATERIAL",
		[ITEMTYPE_GLYPH_ARMOR] = "GLYPH_ARMOR",
		[ITEMTYPE_GLYPH_JEWELRY] = "GLYPH_JEWELRY",
		[ITEMTYPE_GLYPH_WEAPON] = "GLYPH_WEAPON",
		[ITEMTYPE_INGREDIENT] = "INGREDIENT",
		[ITEMTYPE_JEWELRYCRAFTING_BOOSTER] = "JEWELRYCRAFTING_BOOSTER",
		[ITEMTYPE_JEWELRYCRAFTING_MATERIAL] = "JEWELRYCRAFTING_MATERIAL",
		[ITEMTYPE_JEWELRYCRAFTING_RAW_BOOSTER] = "JEWELRYCRAFTING_RAW_BOOSTER",
		[ITEMTYPE_JEWELRYCRAFTING_RAW_MATERIAL] = "JEWELRYCRAFTING_RAW_MATERIAL",
		[ITEMTYPE_JEWELRY_RAW_TRAIT] = "JEWELRY_RAW_TRAIT",
		[ITEMTYPE_JEWELRY_TRAIT] = "JEWELRY_TRAIT",
		[ITEMTYPE_LOCKPICK] = "LOCKPICK",
		[ITEMTYPE_LURE] = "LURE",
		[ITEMTYPE_MASTER_WRIT] = "MASTER_WRIT",
		[ITEMTYPE_MOUNT] = "MOUNT",
		[ITEMTYPE_NONE] = "NONE",
		[ITEMTYPE_PLUG] = "PLUG",
		[ITEMTYPE_POISON] = "POISON",
		[ITEMTYPE_POISON_BASE] = "POISON_BASE",
		[ITEMTYPE_POTION] = "POTION",
		[ITEMTYPE_POTION_BASE] = "POTION_BASE",
		[ITEMTYPE_RACIAL_STYLE_MOTIF] = "RACIAL_STYLE_MOTIF",
		[ITEMTYPE_RAW_MATERIAL] = "RAW_MATERIAL",
		[ITEMTYPE_REAGENT] = "REAGENT",
		[ITEMTYPE_RECALL_STONE] = "RECALL_STONE",
		[ITEMTYPE_RECIPE] = "RECIPE",
		[ITEMTYPE_SIEGE] = "SIEGE",
		[ITEMTYPE_SOUL_GEM] = "SOUL_GEM",
		[ITEMTYPE_SPICE] = "SPICE",
		[ITEMTYPE_STYLE_MATERIAL] = "STYLE_MATERIAL",
		[ITEMTYPE_TABARD] = "TABARD",
		[ITEMTYPE_TOOL] = "TOOL",
		[ITEMTYPE_TRASH] = "TRASH",
		[ITEMTYPE_TREASURE] = "TREASURE",
		[ITEMTYPE_TROPHY] = "TROPHY",
		[ITEMTYPE_WEAPON] = "WEAPON",
		[ITEMTYPE_WEAPON_BOOSTER] = "WEAPON_BOOSTER",
		[ITEMTYPE_WEAPON_TRAIT] = "WEAPON_TRAIT",
		[ITEMTYPE_WOODWORKING_BOOSTER] = "WOODWORKING_BOOSTER",
		[ITEMTYPE_WOODWORKING_MATERIAL] = "WOODWORKING_MATERIAL",
		[ITEMTYPE_WOODWORKING_RAW_MATERIAL] = "WOODWORKING_RAW_MATERIAL"
	}
	return item_tables[GetItemLinkItemType(itemLink)]
end

function Dr_ThiefDB.OnLootReceived( eventCode, receivedBy, itemName, quantity, soundCategory, lootType, self, isPickpocketLoot, questItemIcon, itemId, isStolen )
	if (not isPickpocketLoot) then return end
	
	local _, _, percent_chance, difficulty, _, _, monster_class, _ = GetGameCameraPickpocketingBonusInfo();
	local timestamp = string.format("TDB_%d",zo_floor(GetTimeStamp() / 3600))
	local current_time = os.date("%H")
	local item_type = Dr_ThiefDB.getItemType(itemName)
	local item_quality = GetItemLinkQuality(itemName)
	local map_name = GetMapName()
	local _, world_x, world_y, world_z = GetUnitWorldPosition("player")
	
	--=if (Dr_Thief_DB_currentPOI == "") then
	--	CHAT_ROUTER:AddSystemMessage("|H0:thiefdb|h[TDB]|h Unknown POI! Information about pickpoketing will not be written!")
	--	return
	--end
	
	if (monster_class == "") then
		monster_class = "FromContainer"
	end
	
	CHAT_ROUTER:AddSystemMessage(string.format("|H0:thiefdb|h[Thief Database]|h %s %s %s %s",
		itemName,
		monster_class,
		map_name,
		Dr_Thief_DB_currentPOI
	))
	
	local thief_summary = {
		current_time = current_time, 
		item_quality = item_quality,
		item_classname = itemName,
		item_name = GetItemLinkName(itemName),
		item_type = item_type,
		monster_class = monster_class,
		difficulty = difficulty,
		percent_chance = percent_chance,
		is_pickpocket = isPickpocketLoot,
		map_name = map_name,
		current_poi = Dr_Thief_DB_currentPOI,
		is_CA_slotted = Dr_ThiefDB.isCutpursesArtSlotted(),
		world_x = world_x,
		world_y = world_y
	}
	
	local current_table = Dr_ThiefDB.savedVariables.ThiefDatabase
	table.insert(current_table, thief_summary)
	
	Dr_ThiefDB.savedVariables.ThiefDatabase = current_table
	
end

function Dr_ThiefDB.currentPOI()
	
	CHAT_ROUTER:AddSystemMessage(string.format("|H0:thiefdb|h[TDB]|h POI updated: %s %d", Dr_Thief_DB_currentPOI,Dr_ThiefDB.isCutpursesArtSlotted()))
end

function Dr_ThiefDB.OnPOIUpdated( eventCode, zoneIndex, poiIndex )
	local poiName, _, _, _ = GetPOIInfo(zoneIndex, poiIndex)
	Dr_Thief_DB_currentPOI = poiName
end

function Dr_ThiefDB.OnZoneChanged( eventCode, zoneName, subZoneName, newSubZone, zoneId, subZoneId )
	Dr_Thief_DB_currentPOI = ""
end

function Dr_ThiefDB.Initialize(event, addon)
	if addon ~= Dr_ThiefDB.name then return end
	 
	Dr_ThiefDB.savedVariables = ZO_SavedVars:NewAccountWide("ThiefDatabase_data", 4, nil, Dr_ThiefDB.default, nil)
	SLASH_COMMANDS["/poi"] = Dr_ThiefDB.currentPOI
	
	em:RegisterForEvent("ThiefDatabaseLootRecieved", EVENT_LOOT_RECEIVED, Dr_ThiefDB.OnLootReceived)
	em:RegisterForEvent("ThiefDatabasePOIUpdated", EVENT_POI_UPDATED, Dr_ThiefDB.OnPOIUpdated)
	em:RegisterForEvent("ThiefDatabasePOIUpdated", EVENT_ZONE_CHANGED, Dr_ThiefDB.OnZoneChanged)
	em:UnregisterForEvent("ThiefDatabaseInitialize", EVENT_ADD_ON_LOADED)
end



-- register our event handler function to be called to do initialization
em:RegisterForEvent("ThiefDatabaseInitialize", EVENT_ADD_ON_LOADED, Dr_ThiefDB.Initialize)
